console.log('AIRCALL LOADED');

(() => {

    let list = null;
    let buttons = null;

    async function endLoading() {
        do {
            await new Promise(r => setTimeout(r, 100));
        } while (!!document.querySelector('.bmc-ajax-indicator.bm-show'));
        await new Promise(r => setTimeout(r, 50));
    }

    async function prevButton() {
        console.log('Call PrevPage');
        buttons[0].click();
        await endLoading();
    }
    async function nextButton() {
        console.log('Call NextPage');
        buttons[1].click();
        await endLoading();
    }

    async function analyseList() {
        const rows = [...list.querySelectorAll('tr')];
        return rows
            .map(row => {
                const a = row.querySelector('a');
                const phoneIcon = row.querySelector('.bmc-render-phone-icon');
                if (a && phoneIcon) {
                    const div = document.createElement('div');
                    div.innerHTML = phoneIcon.getAttribute('data-original-title') ?? '';
                    const phone = div.innerText.trim();
                    if (phone) {
                        return  {
                            url: a.href,
                            name: a.innerText,
                            phone
                        };
                    }
                }
                return null;
            })
            .filter(line => !!line)
            ;
    }

    window.addEventListener('message', async (event) => {
        if (event.data?.action === 'air_call_analyse') {
            let numbers = [];

            let special = false;
            if (window.origin === 'https://ui.boondmanager.com') {
                list = document.querySelector('.bmc-table-list');
                buttons = [...document.querySelectorAll('.bmc-pagination button')];
                if (list && buttons.length) {
                    special = true;

                    // Aller a la premiere page;
                    while(!buttons[0].disabled) {
                        await prevButton();
                    }
                    console.log('Start Analyse');

                    numbers = [ ...numbers, ...await analyseList() ];
                    while(!buttons[1].disabled) {
                        console.log('Newt page Analyse');
                        await nextButton();
                        numbers = [ ...numbers, ...await analyseList() ];
                    }
                }
            }

            if (!special) {
                console.log('ANALYSE GENERIC');
            }

            console.log({ action: 'air_call_list_number', list: numbers });
            window.postMessage({ action: 'air_call_list_number', list: numbers}, '*');
        }
    })

})();
